<?php

namespace Tests\Browser\Components;

use Laravel\Dusk\Browser;
use Laravel\Dusk\Component as BaseComponent;
use PHPUnit\Framework\Assert as PHPUnit;

class ChekForJavascriptErrors extends BaseComponent
{
    /**
     * Get the root selector for the component.
     *
     * @return string
     */
    public function selector()
    {
        return '';
    }

    /**
     * Assert that the browser page contains the component.
     *
     * @param  Browser  $browser
     * @return void
     */
    public function assert(Browser $browser)
    {

    }

    /**
     * Get the element shortcuts for the component.
     *
     * @return array
     */
    public function elements()
    {
        return [];
    }

    public function validate(Browser $browser)
    {
        $browser->pause(3000);

        // this will catch broken javascripts on page
        $consoleLog = $browser->driver->manage()->getLog('browser');

        $findedErrors = [];
        if (!empty($consoleLog)) {
            foreach($consoleLog as $log) {
                if ($log['level'] == 'SEVERE') {
                    $findedErrors[] = $log;
                }
            }
        }

        PHPUnit::assertEmpty($findedErrors);
    }
}
